<?php
defined( 'ABSPATH' ) or die( 'Unauthorized' );


ini_set('display_errors', 'On');
error_reporting(E_ALL | E_STRICT);

function connect_with_turnstile() {
    wp_redirect(turnstile_connect_url());
    exit();
}

add_action( 'wp_ajax_nopriv_connect_with_turnstile', 'connect_with_turnstile' );
add_action( 'wp_ajax_connect_with_turnstile', 'connect_with_turnstile' );


// step 1
// redirect url
// https://techpulp.net/wp-admin/admin-ajax.php?action=add_turnstile_code

// Get initial token
// https://turnstile.me/o/authorize/?client_id=<client_id>&client_secret=<client_secret>&scope=read%20write&response_type=code
// https://turnstile.me/o/authorize/?client_id=lA7n8ks0xplTp47rV0kUvJJSDNXmecs88mxsBlwy&client_secret=Bc1L7GQUzLzIP3FXxeUaMCxWhIVroDhR6bJVcnMBFuUNtoHhe040jm6mJGLPZhoaHRj6r1jB2A8j5Ttc1Uy4fvK5uWsmIuPUuYb4EaTYhBStQSsH3w8Xbw7tIYmRWSQp&scope=read%20write&response_type=code

// Get code param and save it in options
function add_turnstile_code(){
    $DEBUG = True;

    $reponse = array();
    $code = isset($_GET['code']) ? $_GET['code'] : null;
    $client_id = isset($_GET['client_id']) ? $_GET['client_id'] : null;
    $client_secret = isset($_GET['client_secret']) ? $_GET['client_secret'] : null;

    if ( !empty($client_id) && empty( $code ) ){
        $authorize_uri = turnstile_url("/o/authorize/"
            . "?client_id={$client_id}"
            . "&client_secret={$client_secret}"
            . "&scope=". TURNSTILE_SCOPE_STRING . "&response_type=code");

        update_option( 'turnstile_api', [
            'client_id' => $client_id,
            'client_secret' => $client_secret,
            'timestamp' => (new DateTime('NOW'))->format('c'),
            ]);

        wp_redirect($authorize_uri);
        exit();
    } else if ( empty($code) ){
        // why are you even here then?
        wp_redirect(admin_url() . '/options-general.php?page=turnstile-setting-admin');
        exit();
    }

    // ask for access token
    // // ```curl -v -L -XPOST 'https://turnstile.me/o/token/?code=<code>&grant_type=authorization_code&client_id=<client_id>&redirect_uri=http://mywebsite.com'```
    // $redirect_url = admin_url('admin-ajax.php?action=add_turnstile_code');
    //$redirect_url = "https://techpulp.net/wp-admin/admin-ajax.php?action=add_turnstile_code";
    // $redirect_url = "https://techpulp.net";
    //$url_turnstile = 'https://turnstile.me/o/token/';



    update_option( 'turnstile_code', $code );

    $url_turnstile = turnstile_api_url('/o/token/');

    $client_id = get_option( 'turnstile_api')['client_id'];  // this should exist

    $params = array( 'code'          => $code,
                     'client_id'     => $client_id,
                     'grant_type'    => 'authorization_code',
                     'redirect_uri'  => TURNSTILE_REDIRECT_URI);
    $args = array(
        'method' => 'POST',
        'timeout' => 10,
        'redirection' => 2,
        'headers' => array(),
        'body' => $params
    );

    //die(print_r($args, 1));

    $response = wp_remote_post( $url_turnstile, $args );

    if ( is_array( $response ) ) {
      $header = $response['headers']; // array of http header lines
      $response_token = json_decode( $response['body'], True ); // use the content
    }

    header( "Content-Type: application/json" );

    if (isset($response_token['access_token'])){
        update_option( 'turnstile_access_token', $response_token['access_token'] );
        update_option( 'turnstile_refresh_token', $response_token['refresh_token'] );
        update_option( 'turnstile_token_type', $response_token['token_type'] );
        update_option( 'turnstile_scope', $response_token['scope'] );
    } else {
        // header( "Content-Type: application/json" );
        // echo json_encode($response);
        header('Location: ' . admin_url('/options-general.php?page=turnstile-setting-admin&authorized=error'));
        exit();
    }
    // redirect to admin page
    header('Location: ' . admin_url('/options-general.php?page=turnstile-setting-admin&authorized=success'));
    exit();

    // exit();
}

add_action( 'wp_ajax_nopriv_add_turnstile_code', 'add_turnstile_code' );
add_action( 'wp_ajax_add_turnstile_code', 'add_turnstile_code' );


// DEBUG see turnstle tokens using a simple get
// curl 'https://techpulp.net/wp-admin/admin-ajax.php?action=debug_tokens'
// function debug_tokens(){
//     get_option( 'turnstile_access_token' );
//     get_option( 'turnstile_refresh_token' );
//     get_option( 'turnstile_token_type' );
//     get_option( 'turnstile_scope' );
//     $resp = array(
//         "code"          =>  get_option( 'turnstile_code' ),
//         "access_token"  =>  get_option( 'turnstile_access_token' ),
//         "refresh_token" =>  get_option( 'turnstile_refresh_token' ),
//         "token_type"    =>  get_option( 'turnstile_token_type' ),
//         "scope"         =>  get_option( 'turnstile_scope' ),
//         "api"     =>  get_option( 'turnstile_api' ),
//     );
//     header( "Content-Type: application/json" );
//     echo json_encode($resp);
// }
// add_action( 'wp_ajax_nopriv_debug_tokens', 'debug_tokens' );
// add_action( 'wp_ajax_debug_tokens', 'debug_tokens' );
