<?php
defined( 'ABSPATH' ) or die( 'Unauthorized' );

/**
 * Generated by the WordPress Meta Box generator
 * at http://jeremyhixon.com/tool/wordpress-meta-box-generator/
 */

add_action( 'add_meta_boxes', 'turnstile_add_meta_box' );
function turnstile_add_meta_box() {
    add_meta_box(
		'turnstile-social-ask',
		__( 'Turnstile', 'turnstile' ),
		'turnstile_html',
		'post',
		'side',
		'default'
    );
    add_meta_box(
		'turnstile-social-ask',
		__( 'Turnstile', 'turnstile' ),
		'turnstile_html',
		'page',
		'side',
		'default'
	);


}

add_action( 'add_meta_boxes', 'turnstile_metrics_add_meta_box' );
function turnstile_metrics_add_meta_box() {
	add_meta_box(
		'turnstile-metrics',
		__( 'Turnstile Metrics', 'turnstile' ),
		'turnstile_metrics',
		'post',
		'side',
		'default'
	);
	add_meta_box(
		'turnstile-metrics',
		__('Turnstile Metrics', 'turnstile'),
		'turnstile_metrics',
		'page',
		'side',
		'default'
	);
}

add_filter('postbox_classes_post_turnstile-metrics','add_metabox_classes');
add_filter('postbox_classes_page_turnstile-metrics','add_metabox_classes');
function add_metabox_classes($classes) {
    $turnstile_link = get_post_meta( get_post()->ID, 'turnstile-readmore-self', true );
    if (turnstile_is_connected() && !empty($turnstile_link)) {
      array_push($classes,'close_to_the_edge');
    }
    return $classes;
}

// Remove turnstile-metrics metabox if turnstile has not been created yet
add_action( 'do_meta_boxes', 'remove_turnstile_metrics_metabox' );
function remove_turnstile_metrics_metabox(){
	global $post;
	if ( isset( $post ) ){
		$turnstile = get_post_meta( $post->ID, 'turnstile-readmore-self', true );
		if ( !isset( $turnstile ) ) {
			remove_meta_box( 'turnstile-metrics' , 'post' , 'side' );
			remove_meta_box( 'turnstile-metrics' , 'page' , 'side' );
		}
	}
}

// Load turnstile metrics
function turnstile_metrics( $post) {
	$turnstile = get_post_meta( $post->ID, 'turnstile-readmore-self', true );
	if (!turnstile_is_connected()) {
	    turnstile_render_connect_required();
	} else if (empty($turnstile)){
	    turnstile_render_add_shortcode_message();
	} else {
	    $token = get_option( 'turnstile_access_token' );
	    $info_link = turnstile_info_link( $turnstile, $token );
	    turnstile_render_metrics_iframe( $info_link );
	}
}

function turnstile_render_connect_required() {
    ?>
    <p>
	<a style="border:0px" class="stuffbox" href="<?php echo(turnstile_connect_url()); ?>">Connect to Turnstile</a>
    </p>
    <?php
}

function turnstile_render_add_shortcode_message() {
    ?>
    <p>
	Add a Turnstile shortcode to begin viewing metrics.
    </p>
    <?php
}

function turnstile_render_metrics_iframe( $info_link ) {
    ?>
		<iframe id="turnstile_post_metrics"
			title="Turnstile Post Metrics"
			width="278"
			height="350"
			frameBorder="0"
			seamless='seamless'
			scrolling="yes"
			marginheight="0"
			marginwidth="0"
			src=<?php echo( $info_link ); ?>>
		</iframe>
    <?php
}

 // get turnstile social login provider preferences from post custom meta
 function turnstile_ask_get_meta( $value ) {
    global $post;
	$array = get_post_meta( $post->ID, 'turnstile_ask', true);
	if ( $array ) {
		$array = stripslashes_deep( $array );
		return wp_kses_decode_entities( $array[$value] );
	} else {
		return "empty";
	}
}

function turnstile_info_link( $turnstile, $token ) {
    $turnstile_code = trim( parse_url( $turnstile, PHP_URL_PATH ), '/' );
    return turnstile_url( 'info', $turnstile_code, "frame?token={$token}" );
}

function turnstile_html( $post ) {
    wp_nonce_field( '_turnstile_nonce', 'turnstile_nonce' );
	$checked_init = "";
	if( !get_post_meta( $post->ID, 'turnstile-readmore-self', true ) ){
		// var_dump(get_post_meta( $post->ID, 'turnstile-readmore-self', true ));
		// die();
		$checked_init = "checked";
	}
	?>

	<p>Social login platforms available to go through your Turnstile read more link.</p>
	<p>
		<input type="checkbox" name="turnstile_facebook" id="turnstile_facebook" value="facebook" <?php echo $checked_init; echo ( turnstile_ask_get_meta( 'facebook' ) === "1" ) ? 'checked' : ''; ?>>
		<label for="turnstile_facebook"><?php _e( 'Facebook', 'turnstile' ); ?></label>	</p>	<p>

		<input type="checkbox" name="turnstile_linkedin" id="turnstile_linkedin" value="linkedin" <?php echo $checked_init; echo ( turnstile_ask_get_meta( 'linkedin' ) === "1" ) ? 'checked' : ''; ?>>
		<label for="turnstile_linkedin"><?php _e( 'LinkedIn', 'turnstile' ); ?></label>	</p>	<p>

		<input type="checkbox" name="turnstile_twitter" id="turnstile_twitter" value="twitter" <?php echo ( turnstile_ask_get_meta( 'twitter' ) === "1" ) ? 'checked' : ''; ?>>
		<label for="turnstile_twitter"><?php _e( 'Twitter', 'turnstile' ); ?></label>	</p>	<p>

		<input type="checkbox" name="turnstile_google" id="turnstile_google" value="google" <?php echo ( turnstile_ask_get_meta( 'google' ) === "1" ) ? 'checked' : ''; ?>>
		<label for="turnstile_google"><?php _e( 'Google', 'turnstile' ); ?></label>	</p>	<p>

		<input disabled="disabled" type="checkbox" name="turnstile_instagram" id="turnstile_instagram" value="instagram" <?php echo ( turnstile_ask_get_meta( 'instagram' ) === "1" ) ? 'checked' : ''; ?>>
		<label for="turnstile_instagram"><?php _e( 'Instagram (soon)', 'turnstile' ); ?></label>	</p>	<p>

		<input disabled="disabled" type="checkbox" name="turnstile_pinterest" id="turnstile_pinterest" value="pinterest" <?php echo ( turnstile_ask_get_meta( 'pinterest' ) === "1" ) ? 'checked' : ''; ?>>
		<label for="turnstile_pinterest"><?php _e( 'Pinterest (soon)', 'turnstile' ); ?></label>	</p>	<p>

		<?php
}

function turnstile_save( $post_id ) {

    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) { return; };
    if ( ! isset( $_POST['turnstile_nonce'] ) || ! wp_verify_nonce( $_POST['turnstile_nonce'], '_turnstile_nonce' ) ) { return; };
	if ( ! current_user_can( 'edit_post', $post_id ) ) { return; };

	$post_status = get_post_status( $post_id );
	$invalid_status = array( "draft", "auto-draft", "inherit", "trash" );
	if ( in_array( $post_status, $invalid_status ) ) { return; }

	$turnstile_ask = array();
	$turnstile_ask['facebook'] = ( isset( $_POST['turnstile_facebook'] ) ? 1 : 0);
	$turnstile_ask['linkedin'] = ( isset( $_POST['turnstile_linkedin'] ) ? 1 : 0);
	$turnstile_ask['twitter'] = ( isset( $_POST['turnstile_twitter'] ) ? 1 : 0);
	$turnstile_ask['google'] = ( isset( $_POST['turnstile_google'] ) ? 1 : 0);
	$turnstile_ask['instagram'] = ( isset( $_POST['turnstile_instagram'] ) ? 1 : 0);
	$turnstile_ask['pinterest'] = ( isset( $_POST['turnstile_pinterest'] ) ? 1 : 0);
	$turnstile_ask['snapchat'] = ( isset( $_POST['turnstile_snapchat'] ) ? 1 : 0);

	update_post_meta( $post_id, 'turnstile_ask', $turnstile_ask );

    publish_event_add_turnstile_link_more( $post_id );
}

add_action( 'wp_insert_post', 'turnstile_save', 15 );

