<?php
// Build a turnstile url with provided path
function turnstile_url() {
    return rtrim(TURNSTILE_URL_BASE, '/') .'/'. ltrim(implode(func_get_args(),'/'), '/');
}

function turnstile_api_url() {
    return rtrim(TURNSTILE_API_BASE, '/') .'/'. ltrim(implode(func_get_args(),'/'), '/');
}

function turnstile_is_connected() {
    $client = get_option('turnstile_api');
    return !empty($client);
}
function turnstile_settings_url() {
    return admin_url() . 'options-general.php?page=turnstile-setting-admin';
}
function turnstile_generate_app_name() {
    return str_replace('.', '_', parse_url(get_site_url(), PHP_URL_HOST));
}
function turnstile_js_path($js){
    return TURNSTILE_PLUGIN_PATH . 'public/js/' . $js;
}
function turnstile_img_path($img){
    return TURNSTILE_PLUGIN_PATH . 'public/img/' . $img;
}
function turnstile_css_path($css){
    return TURNSTILE_PLUGIN_PATH . 'public/css/' . $css;
}
function turnstile_vendor_path($path){
    return TURNSTILE_PLUGIN_PATH . 'public/vendor/' . $path;
}
function turnstile_connect_url() {
    return turnstile_url('/o/applications/register/')
      . '?name=' . turnstile_generate_app_name()
      . '&redirect_uri=' . urlencode(TURNSTILE_REDIRECT_URI);
}
