<?php
defined( 'ABSPATH' ) or die( 'Unauthorized' );

// Add turnstile.js
add_action( 'wp_enqueue_scripts', 'turnstile_theme_enqueue_styles' );
function turnstile_theme_enqueue_styles() {
    $enable = get_option( 'turnstile_cookie_bar_enabled' );
    if ( !empty($enable) ) {
        wp_enqueue_script( 'cookie_consent_load', turnstile_js_path('cookie_consent_load.js'), false );
        wp_enqueue_script( 'cookie_consent_js', turnstile_vendor_path('cookieconsent/cookieconsent.min.js'), false );
        wp_enqueue_style( 'cookie_consent_css', turnstile_vendor_path('cookieconsent/cookieconsent.min.css'), false );
    }

    wp_enqueue_script( 'turnstile_js', turnstile_js_path('turnstile.js'), false );
    wp_enqueue_style( 'turnstile_css', turnstile_css_path('style.css'), false );
}

// add admin style
add_action('admin_head', 'turnstile_admin_css');
function turnstile_admin_css(){
    wp_enqueue_style( 'turnstile_admin_css', turnstile_css_path('style_admin.css'), false );
}

// add the ref variable to wp accessible variable
// used in ?ref=turnstile for turnstile_more shortcode
add_filter( 'query_vars', 'turnstile_add_query_vars_filter' );
function turnstile_add_query_vars_filter( $vars ){
    $vars[] = "ref";
    return $vars;
  }



